'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Any = exports.Nullable = exports.Optional = undefined;
exports.chaiStruct = chaiStruct;

var _typeDiff = require('type-diff');

Object.defineProperty(exports, 'Optional', {
  enumerable: true,
  get: function () {
    return _typeDiff.Optional;
  }
});
Object.defineProperty(exports, 'Nullable', {
  enumerable: true,
  get: function () {
    return _typeDiff.Nullable;
  }
});
Object.defineProperty(exports, 'Any', {
  enumerable: true,
  get: function () {
    return _typeDiff.Any;
  }
});
function chaiStruct({ Assertion, AssertionError, assert }, utils) {

  utils.addMethod(Assertion.prototype, 'structure', function (Type) {
    if (Type == null) {
      throw new AssertionError('Type structure must be defined and non-null.');
    }
    const result = (0, _typeDiff.diff)(Type, this._obj);
    assert(!result, format(result));
  });
}

const format = result => {
  const json = JSON.stringify(result, null, 2);
  return `Unexpected Type structure:\n${ json }`;
};